First let's create an account so you can push changes back. Create an account on the Workshop by clicking on the Sign Up link in the upper right hand corner at http://workshop.perforce.com

After that, grab p4 and p4d from the Beta Downloads site and stick them in your path. For the 15.1 release, only the command line supports the new DVCS functionality.

Run 'p4 -u <login_name> -p workshop.perforce.com:1666 login' to authenticate with the server and to make sure that p4 is installed properly.

Now that we are properly authenticated it's time to put some content into your part of the Workshop so that you have something interesting to make changes to. In this example we are going to grab a copy of the latest Piper code. 

Run 'p4 -u <login_name> -p workshop.perforce.com:1666 populate //guest/perforce_software/piper/... //guest/<login_name>/piper/...' to populate your area of the Workshop with some files. If there is another project that you find more interesting change up the paths appropriately.

With some interesting files now in place, let's get a copy to work on! Run 'p4 -d piper clone -p workshop.perforce.com:1666 -f //guest/<login_name>/piper/...' to clone the content into your personal server. The '-d' tells Perforce to create a directory for the content instead of using the current directory. The '-f' allows you to speify a depot path to clone.

Once the clone completes run 'cd piper' to change directories. If you run 'p4 info' at this point you will see that you are interacting with your personal server. Running 'p4 changes' will show you the commit you did using 'p4 populate' on the shared server.

At this point you can make changes as you please using 'p4 rec' to have Perforce scan for changes and 'p4 submit' to submit them to your local server. Just to prove there is no smoke and mirrors you can run 'p4 -p workshop.perforce.com:1666 changes -m5' to see that all of your changes are staying in your local server.

Once you've poked around and made a few changes, it's probably time to push them back. From the command line run 'p4 push -I'. The -I will give you a bit more feedback as the process happens. A few seconds later your changes should be live in the Workshop. Re-run the previous 'p4 changes' command and you should see your work.

