This module allows you to send Swarm events to a kato.im room.

== Installation

1) Create a directory named "Kato" in the "modules" directory of your Swarm installation
2) Put the contents of this project (Module.php and the config directory) into the "Kato" directory
3) Modify Module.php to put in the URL for the kato.im room that you want to receive the events. The variable is called $room and there are two instances of it.
4) Restart Apache on the Swarm host machine


== Getting the kato.im URL

To get the URL for the room you want to post events to, do the following:

1) In kato, go to the room that you want to post events to, creating it first if necessary
2) Click on the options button in the upper right hand corner of the room; it has three horizontal lines in a circle.
3) Select "Manage Integrations" from the context menu
4) If you haven't already, enable the "HTTP Post" integration. You can do so by clicking the "HTTP Post" icon, and then
   clicking the slider in the upper right hand corner to switch it from "off" to "on".
5) Grab the URL from the right side bar and paste it into Module.php as noted above. It will be of the form:
   https://api.kato.im/rooms/36284a1d50c33c4593aasdasdasd6942d2e4bd1af990ceb204c9c41cfeea935/simple


== Questions?

Feel free to contact me (@matt_attaway) and I'll help you the best I can.