# Xcode Perforce Plugin

Native Xcode Plugin that allows for Perforce integration

## Features

- Allows for p4 or p4vc commands to be executed on the currently selected file


## Prerequisites

- Xcode 6
- p4 and p4vc command line apps be located in /usr/bin or any other path that is exported by Xcode (env)
- ~/.bash_login file with the P4CONFIG setting set
- Root of workspace client contains perforce.rc file with P4CLIENT variable set


An example .bash_login file would contain:
export P4CONFIG=perforce.rc
export P4PORT=myawesomedomain.com:1666
export P4USER=jaime_rios
export P4PASSWD=PFourIzGr8

An example perforce.rc file, located at the root of your client, may contain
P4CLIENT=jaime_rios_XcodePerforcePlugin



## Install

- Build the project, then restart Xcode


## Usage

- Select the "Source Control" menu
-- Select any p4 or p4vc command you desire for the current active file

## Uninstall

Run `rm -r ~/Library/Application\ Support/Developer/Shared/Xcode/Plug-ins/XcodePerforcePlugin.xcplugin/`


## Known Issues

- Only a limited set of p4 or p4vc commands were implemented
- May be buggy, so use at your own risk
