$areaTypes        = [ "filesize", "filecount", "changecount", "fixcount" ]
$prettyAreaTypes  = [ "File size of head revisions", "File count", "Submitted changes", "Jobs fixed" ]

$shadingTypes       = [ "filesize", "filecount", "changecount", "fixcount" ]
$prettyShadingTypes = [ "File size of head revisions", "File count", "Submitted changes", "Jobs fixed" ]

$servers       = [ "public:1666", "perforce:1666" ]
$prettyServers = [ "Public Depot", "Main" ]

def getShadingTypes()
	return $shadingTypes
end

def getPrettyShadingTypes()
	return $prettyShadingTypes
end

def getPrettyAreaTypes()
	return $prettyAreaTypes
end

def getAreaTypes()
	return $areaTypes
end

def getServers()
	return $servers
end

def getPrettyServers()
	return $prettyServers
end

def isValidType( type )
	case type
		when "filesize"
			return true
		when "filecount"
			return true
		when "changecount"
			return true
		when "fixcount"
			return true
	end
				
	return false
end

def getPrettyType( type )
	case type
		when "filesize"
			return "File size"
		when "filecount"
			return "File count"
		when "changecount"
			return "Submitted changes"
		when "fixcount"
			return "Jobs fixed"
	end
			
	return ""
end